com.ihr.xbrl.om.taxonomy

## Class XBRLRoleType

- java.lang.Object
- - com.ihr.xbrl.om.XMLFragment
  - - com.ihr.xbrl.om.taxonomy.XBRLRoleAndArcroleTypes
    - - com.ihr.xbrl.om.taxonomy.XBRLRoleType

- All Implemented Interfaces:
    HasAdditionalEqualityForReassignation, XBRLRelationshipPoint, Thinable, XBRLValidation, XMLHasParent, java.io.Serializable, java.lang.Cloneable, java.lang.Comparable<XBRLRoleType>, javax.xml.namespace.NamespaceContext

      public class XBRLRoleType
      extends XBRLRoleAndArcroleTypes
      implements java.io.Serializable

  Provides the properties of an XBRL Role Type Information Item.
  Author:
    Ignacio
  See Also:
    Serialized Form

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface com.ihr.xbrl.om.XBRLValidation

      `XBRLValidation.Direction`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static javax.xml.namespace.QName` | `roleTypeQName` The Constant roleTypeQName.
    `static XBRLRoleType` | `STANDARD_DOCUMENTATION` The standard documentation.
    `static XBRLRoleType` | `STANDARD_FOOTNOTE` Static roles on resources.
    `static XBRLRoleType` | `STANDARD_LABEL` The standard label.
    `static XBRLRoleType` | `STANDARD_LABEL_COMMENTARY_GUIDANCE` The standard label commentary guidance.
    `static XBRLRoleType` | `STANDARD_LABEL_DEFINITION_GUIDANCE` The standard label definition guidance.
    `static XBRLRoleType` | `STANDARD_LABEL_DISCLOSURE_GUIDANCE` The standard label disclosure guidance.
    `static XBRLRoleType` | `STANDARD_LABEL_EXAMPLE_GUIDANCE` The standard label example guidance.
    `static XBRLRoleType` | `STANDARD_LABEL_MEASUREMENT_GUIDANCE` The standard label measurement guidance.
    `static XBRLRoleType` | `STANDARD_LABEL_NEGATIVE` The standard label negative.
    `static XBRLRoleType` | `STANDARD_LABEL_NEGATIVE_TERSE` The standard label negative terse.
    `static XBRLRoleType` | `STANDARD_LABEL_NEGATIVE_VERBOSE` The standard label negative verbose.
    `static XBRLRoleType` | `STANDARD_LABEL_PERIOD_END` The standard label period end.
    `static XBRLRoleType` | `STANDARD_LABEL_PERIOD_START` The standard label period start.
    `static XBRLRoleType` | `STANDARD_LABEL_POSITIVE` The standard label positive.
    `static XBRLRoleType` | `STANDARD_LABEL_POSITIVE_TERSE` The standard label positive terse.
    `static XBRLRoleType` | `STANDARD_LABEL_POSITIVE_VERBOSE` The standard label positive verbose.
    `static XBRLRoleType` | `STANDARD_LABEL_PRESENTATION_GUIDANCE` The standard label presentation guidance.
    `static XBRLRoleType` | `STANDARD_LABEL_TERSE` The standard label terse.
    `static XBRLRoleType` | `STANDARD_LABEL_TOTAL` The standard label total.
    `static XBRLRoleType` | `STANDARD_LABEL_VERBOSE` The standard label verbose.
    `static XBRLRoleType` | `STANDARD_LABEL_ZERO` The standard label zero.
    `static XBRLRoleType` | `STANDARD_LABEL_ZERO_TERSE` The standard label zero terse.
    `static XBRLRoleType` | `STANDARD_LABEL_ZERO_VERBOSE` The standard label zero verbose.
    `static XBRLRoleType` | `STANDARD_LINKBASE_CALCULATION` The standard linkbase calculation.
    `static XBRLRoleType` | `STANDARD_LINKBASE_DEFINITION` The standard linkbase definition.
    `static XBRLRoleType` | `STANDARD_LINKBASE_LABEL` Static roles on linkbaseRef elements.
    `static XBRLRoleType` | `STANDARD_LINKBASE_PRESENTATION` The standard linkbase presentation.
    `static XBRLRoleType` | `STANDARD_LINKBASE_REFERENCE` The standard linkbase reference.
    `static XBRLRoleType` | `STANDARD_REFERENCE` The standard reference.
    `static XBRLRoleType` | `STANDARD_REFERENCE_COMMENTARY` The standard reference commentary.
    `static XBRLRoleType` | `STANDARD_REFERENCE_DEFINITION` The standard reference definition.
    `static XBRLRoleType` | `STANDARD_REFERENCE_DISCLOSURE` The standard reference disclosure.
    `static XBRLRoleType` | `STANDARD_REFERENCE_EXAMPLE` The standard reference example.
    `static XBRLRoleType` | `STANDARD_REFERENCE_MANDATORY_DISCLOSURE` The standard reference mandatory disclosure.
    `static XBRLRoleType` | `STANDARD_REFERENCE_MEASUREMENT` The standard reference measurement.
    `static XBRLRoleType` | `STANDARD_REFERENCE_PRESENTATION` The standard reference presentation.
    `static XBRLRoleType` | `STANDARD_REFERENCE_RECOMMENDED_DISCLOSURE` The standard reference recommended disclosure.
    `static XBRLRoleType` | `STANDARD_REFERENCE_UNSPECIFIED_DISCLOSURE` The standard reference unspecified disclosure.
    `static XBRLRoleType` | `STANDARD_ROLE_URI` There is one static definition of the standard role each time a DTSContainer is created a local copy of this object is created in that DTSContainer.

    - ### Fields inherited from class com.ihr.xbrl.om.XMLFragment

      `CONCEPT_LABEL, CONCEPT_QNAME, EASY_TO_READ, ELEMENT_LABEL, EMPTYRELATIONSHIPSITERATORINSTANCE, EMPTYXMLFRAGMENTITERATORINSTANCE, FACT_CONCEPT_DATATYPE, FACT_CONCEPT_LABEL, FACT_QNAME, HIDE_COMMON_ACCURACY, idQName, NO_POSITION, OrderComparator, OrderComparator2, PERIOD_TYPE, PERIOD_VALUE, SHORT_TEXT, SOURCE_DOCUMENT, XPATH, XPOINTER`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `XBRLRoleType(DTSContainer newDTS)` Creates a "virtual" role type.
    `XBRLRoleType(DTSContainer newDts, XBRLRoleType other)` Instantiates a new XBRL role type.
    `XBRLRoleType(XBRLRoleType other)` Instantiates a new XBRL role type.
    `XBRLRoleType(XBRLTaxonomy parent, net.sf.saxon.s9api.XdmNode node)` Creates a new XBRLRoleType object.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addUse(XMLFragment here)` Adds the use.
    `void` | `clear()` Frees-up used memory This method should not be invoqued on live objects in the DTS.
    `void` | `delUse(XMLFragment here)` Del use.
    `boolean` | `equals(java.lang.Object other)` Sets a new XPathFunctionResolver for this object.
    `org.jdom.Element` | `generateNode(boolean relativize, java.net.URI base)` Serializes to a jdom Element the representation of the properties of this Information Item This method should be called from classes derived from this class
    `java.lang.String` | `getFriendlyName()` Returns a string description that represents the element content in a form that users can understand.
    `XBRLRoleRef` | `getRoleRef(XBRLDocument parent)` Creates a XBRLRoleRef object pointing to this role and that can be serialized to a roleRef.
    `java.util.Iterator<XMLFragment>` | `getUses()` Access to the [role uses] property The returned objects in the iterator are instances of XBRLExtendedLink or XBRLResource elements.
    `int` | `hashCode()`
    `java.lang.String` | `toString()` Returns the XML representation of this object as an String.

    - ### Methods inherited from class com.ihr.xbrl.om.taxonomy.XBRLRoleAndArcroleTypes

      `addRef, addUsedOn, compareTo, generateLocatorToNode, getDefinition, getElements, getFriendlyName, getHRefURI, getParent, getURI, getUsedOn, getValidationReport, invalidate, invalidate, isOnValidation, isStatic, isUsedOn, isVirtual, removeUsedOn, sameUsedOn, setDefinition, setId, setParent, setStatic, setURI, setVirtual, validate`

    - ### Methods inherited from class com.ihr.xbrl.om.XMLFragment

      `addAttribute, addChild, addFromRelationship, addNamespace, addNamespace, addToRelationship, addXMLChild, changeBase, checkBase, clone, clone, delAttribute, delAttribute, equalXdmValues, evaluateBoolean, evaluateList, evaluateNode, evaluateNumber, evaluateString, generateId, generateNodeNamespacesAndAttributes, generateNodeValue, generatePrefix, getAllAttributes, getAttribute, getAttributeBooleanValue, getAttributeQNameValue, getAttributes, getAttributes, getAttributeStringValue, getAttributeValue, getBase, getBase, getBaseURI, getBooleanValue, getChild, getContainer, getContainerDocumentURI, getDeclaredNamespaces, getDocument, getElementsHashCode, getFragment, getFromRelationships, getFromRelationships, getFromRelationships, getFromRelationships, getFromRelationships, getGenericLabelText, getId, getLang, getNamespaceURI, getNodeName, getNumberOfAttributes, getNumberOfElements, getNumberOfFromRelationships, getNumberOfToRelationships, getOrGenerateId, getPrefix, getPrefixes, getQNameValue, getRelationshipsBases, getRelationshipsChain, getRelationshipTypes, getStaticContext, getStaticNamespace, getStringValue, getToolTipText, getToRelationships, getToRelationships, getToRelationships, getToRelationships, getToRelationships, getValue, getXPathExecutable, getXPathNamespaceContext, getXPathToNode, getXPathToRoot, getXPointerElementScheme, getXPointerElementScheme, getXPointerShorthandScheme, getXPointerToNode, isDead, isNamespaceDefined, isXdmDocumentAttached, objEquals, objHashCode, qNameToString, removeAttribute, removeChild, removeChild, removeFromRelationship, removeToRelationship, removeXMLChild, resetElements, resetHash, resolve_equal2, resolveHRef, resolveHRef, s_equal2, s_equal2, s_equal2, setAttributes, setBase, setDocument, setDocumentAndReload, setElements, setLang, setNamespaceContext, setNamespaces, setNode, setNodeName, setParent, setRegenerateNodeIfnotFound, setValue, setValue, setVariablesDefined, size, thin, valueEquals, xEqual`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### roleTypeQName

          public static final javax.xml.namespace.QName roleTypeQName

      The Constant roleTypeQName.

    - #### STANDARD_ROLE_URI

          public static XBRLRoleType STANDARD_ROLE_URI

      There is one static definition of the standard role each time a DTSContainer is created a local copy of this object is created in that DTSContainer.

    - #### STANDARD_FOOTNOTE

          public static XBRLRoleType STANDARD_FOOTNOTE

      Static roles on resources.

    - #### STANDARD_LABEL

          public static XBRLRoleType STANDARD_LABEL

      The standard label.

    - #### STANDARD_LABEL_TERSE

          public static XBRLRoleType STANDARD_LABEL_TERSE

      The standard label terse.

    - #### STANDARD_LABEL_VERBOSE

          public static XBRLRoleType STANDARD_LABEL_VERBOSE

      The standard label verbose.

    - #### STANDARD_LABEL_POSITIVE

          public static XBRLRoleType STANDARD_LABEL_POSITIVE

      The standard label positive.

    - #### STANDARD_LABEL_POSITIVE_TERSE

          public static XBRLRoleType STANDARD_LABEL_POSITIVE_TERSE

      The standard label positive terse.

    - #### STANDARD_LABEL_POSITIVE_VERBOSE

          public static XBRLRoleType STANDARD_LABEL_POSITIVE_VERBOSE

      The standard label positive verbose.

    - #### STANDARD_LABEL_NEGATIVE

          public static XBRLRoleType STANDARD_LABEL_NEGATIVE

      The standard label negative.

    - #### STANDARD_LABEL_NEGATIVE_TERSE

          public static XBRLRoleType STANDARD_LABEL_NEGATIVE_TERSE

      The standard label negative terse.

    - #### STANDARD_LABEL_NEGATIVE_VERBOSE

          public static XBRLRoleType STANDARD_LABEL_NEGATIVE_VERBOSE

      The standard label negative verbose.

    - #### STANDARD_LABEL_ZERO

          public static XBRLRoleType STANDARD_LABEL_ZERO

      The standard label zero.

    - #### STANDARD_LABEL_ZERO_TERSE

          public static XBRLRoleType STANDARD_LABEL_ZERO_TERSE

      The standard label zero terse.

    - #### STANDARD_LABEL_ZERO_VERBOSE

          public static XBRLRoleType STANDARD_LABEL_ZERO_VERBOSE

      The standard label zero verbose.

    - #### STANDARD_LABEL_TOTAL

          public static XBRLRoleType STANDARD_LABEL_TOTAL

      The standard label total.

    - #### STANDARD_LABEL_PERIOD_START

          public static XBRLRoleType STANDARD_LABEL_PERIOD_START

      The standard label period start.

    - #### STANDARD_LABEL_PERIOD_END

          public static XBRLRoleType STANDARD_LABEL_PERIOD_END

      The standard label period end.

    - #### STANDARD_DOCUMENTATION

          public static XBRLRoleType STANDARD_DOCUMENTATION

      The standard documentation.

    - #### STANDARD_LABEL_DEFINITION_GUIDANCE

          public static XBRLRoleType STANDARD_LABEL_DEFINITION_GUIDANCE

      The standard label definition guidance.

    - #### STANDARD_LABEL_DISCLOSURE_GUIDANCE

          public static XBRLRoleType STANDARD_LABEL_DISCLOSURE_GUIDANCE

      The standard label disclosure guidance.

    - #### STANDARD_LABEL_PRESENTATION_GUIDANCE

          public static XBRLRoleType STANDARD_LABEL_PRESENTATION_GUIDANCE

      The standard label presentation guidance.

    - #### STANDARD_LABEL_MEASUREMENT_GUIDANCE

          public static XBRLRoleType STANDARD_LABEL_MEASUREMENT_GUIDANCE

      The standard label measurement guidance.

    - #### STANDARD_LABEL_COMMENTARY_GUIDANCE

          public static XBRLRoleType STANDARD_LABEL_COMMENTARY_GUIDANCE

      The standard label commentary guidance.

    - #### STANDARD_LABEL_EXAMPLE_GUIDANCE

          public static XBRLRoleType STANDARD_LABEL_EXAMPLE_GUIDANCE

      The standard label example guidance.

    - #### STANDARD_REFERENCE

          public static XBRLRoleType STANDARD_REFERENCE

      The standard reference.

    - #### STANDARD_REFERENCE_DEFINITION

          public static XBRLRoleType STANDARD_REFERENCE_DEFINITION

      The standard reference definition.

    - #### STANDARD_REFERENCE_DISCLOSURE

          public static XBRLRoleType STANDARD_REFERENCE_DISCLOSURE

      The standard reference disclosure.

    - #### STANDARD_REFERENCE_MANDATORY_DISCLOSURE

          public static XBRLRoleType STANDARD_REFERENCE_MANDATORY_DISCLOSURE

      The standard reference mandatory disclosure.

    - #### STANDARD_REFERENCE_RECOMMENDED_DISCLOSURE

          public static XBRLRoleType STANDARD_REFERENCE_RECOMMENDED_DISCLOSURE

      The standard reference recommended disclosure.

    - #### STANDARD_REFERENCE_UNSPECIFIED_DISCLOSURE

          public static XBRLRoleType STANDARD_REFERENCE_UNSPECIFIED_DISCLOSURE

      The standard reference unspecified disclosure.

    - #### STANDARD_REFERENCE_PRESENTATION

          public static XBRLRoleType STANDARD_REFERENCE_PRESENTATION

      The standard reference presentation.

    - #### STANDARD_REFERENCE_MEASUREMENT

          public static XBRLRoleType STANDARD_REFERENCE_MEASUREMENT

      The standard reference measurement.

    - #### STANDARD_REFERENCE_COMMENTARY

          public static XBRLRoleType STANDARD_REFERENCE_COMMENTARY

      The standard reference commentary.

    - #### STANDARD_REFERENCE_EXAMPLE

          public static XBRLRoleType STANDARD_REFERENCE_EXAMPLE

      The standard reference example.

    - #### STANDARD_LINKBASE_LABEL

          public static XBRLRoleType STANDARD_LINKBASE_LABEL

      Static roles on linkbaseRef elements.

    - #### STANDARD_LINKBASE_PRESENTATION

          public static XBRLRoleType STANDARD_LINKBASE_PRESENTATION

      The standard linkbase presentation.

    - #### STANDARD_LINKBASE_DEFINITION

          public static XBRLRoleType STANDARD_LINKBASE_DEFINITION

      The standard linkbase definition.

    - #### STANDARD_LINKBASE_REFERENCE

          public static XBRLRoleType STANDARD_LINKBASE_REFERENCE

      The standard linkbase reference.

    - #### STANDARD_LINKBASE_CALCULATION

          public static XBRLRoleType STANDARD_LINKBASE_CALCULATION

      The standard linkbase calculation.

  - ### Constructor Detail

    - #### XBRLRoleType

          public XBRLRoleType(XBRLTaxonomy parent,
                      net.sf.saxon.s9api.XdmNode node)
                       throws XBRLValidationException

      Creates a new XBRLRoleType object.
      Parameters:
        `parent` - the parent
        `node` - the node
      Throws:
        `XBRLValidationException` - the XBRL validation exception

    - #### XBRLRoleType

          public XBRLRoleType(DTSContainer newDts,
                      XBRLRoleType other)

      Instantiates a new XBRL role type.
      Parameters:
        `newDts` - the new dts
        `other` - the other

    - #### XBRLRoleType

          public XBRLRoleType(XBRLRoleType other)

      Instantiates a new XBRL role type.
      Parameters:
        `other` - the other

    - #### XBRLRoleType

          public XBRLRoleType(DTSContainer newDTS)

      Creates a "virtual" role type. Change properties (included the virtual property if this is going to be serialized) after creation
      Parameters:
        `newDTS` - the new dts

  - ### Method Detail

    - #### addUse

          public void addUse(XMLFragment here)

      Adds the use.
      Parameters:
        `here` - the here

    - #### delUse

          public void delUse(XMLFragment here)

      Del use.
      Parameters:
        `here` - XMLFragment

    - #### getUses

          public java.util.Iterator<XMLFragment> getUses()

      Access to the [role uses] property The returned objects in the iterator are instances of XBRLExtendedLink or XBRLResource elements.
      Returns:
        Iterator

    - #### toString

          public java.lang.String toString()

      Description copied from class: `XMLFragment`
      Returns the XML representation of this object as an String.
      Overrides:
        `toString` in class `XMLFragment`
      Returns:
        the string

    - #### equals

          public boolean equals(java.lang.Object other)

      Description copied from class: `XMLFragment`
      Sets a new XPathFunctionResolver for this object.
      Overrides:
        `equals` in class `XBRLRoleAndArcroleTypes`
      Parameters:
        `other` - the other
      Returns:
        true, if successful

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `XBRLRoleAndArcroleTypes`

    - #### getRoleRef

          public XBRLRoleRef getRoleRef(XBRLDocument parent)

      Creates a XBRLRoleRef object pointing to this role and that can be serialized to a roleRef.
      Parameters:
        `parent` - the parent
      Returns:
        XBRLRoleRef

    - #### generateNode

          public org.jdom.Element generateNode(boolean relativize,
                                      java.net.URI base)
                                        throws XBRLSerializationException

      Description copied from class: `XMLFragment`
      Serializes to a jdom Element the representation of the properties of this Information Item This method should be called from classes derived from this class
      Overrides:
        `generateNode` in class `XBRLRoleAndArcroleTypes`
      Parameters:
        `relativize` - boolean indicating if URIs should be relativized to the base URI (see next argument)
        `base` - the URI to which some attributes of this object should be relativided
      Returns:
        a clone of the surrounding jdom Element so it can be incorporated into multiple trees
      Throws:
        `XBRLSerializationException` - the XBRL serialization exception

    - #### getFriendlyName

          public java.lang.String getFriendlyName()

      Description copied from class: `XMLFragment`
      Returns a string description that represents the element content in a form that users can understand. This method may be overridden by parent classes.

      Remarks, this method may return very long names not suitable for user interface

      Overrides:
        `getFriendlyName` in class `XMLFragment`
      Returns:
        Non empty String. Internationalization is enabled

    - #### clear

          public void clear()

      Description copied from class: `XMLFragment`
      Frees-up used memory

      This method should not be invoqued on live objects in the DTS. It is automatically invoqued by the API when an object is no longer used and referenced by other objects. It is save not to call it directly.

      Overrides:
        `clear` in class `XMLFragment`